<?php

/**
 * @file
 * Hooks provided by Node popup nodule.
 */

/**
 * @addtogroup hooks
 * @{
 */

/**
 * Alter popup content render array, before rendering.
 *
 * This function is called for each popup window creation.
 *
 * @param array $view
 *   An render array of popup content.
 * @param object $node
 *   The popup node object.
 */
function hook_npop_view_data_alter(array &$view, $node) {
  // Change close icon text to FontAwesome close icon.
  $view['node']['closebtn']['#text'] = '<i class="fa fa-close"></i>';
}

/**
 * Alert ajax commands before popup window open.
 *
 * Use this alter, if you want change ajax commands or execute your command on
 * popup window open event.
 *
 * @param array $commands
 *   An array with commands generated by module.
 * @param object $node
 *   The popup node object.
 */
function hook_npop_ajax_alter(array &$commands, $node) {
  // Alert window openned when popup open event called.
  $commands[] = ajax_command_alert('Window openned');
}

/**
 * Alert ajax commands when popup window close.
 *
 * Use this alter, if you want change ajax commands or execute your command on
 * popup window close event.
 *
 * @param array $commands
 *   An array with commands generated by module.
 */
function hook_npop_ajax_close_alter(array &$commands) {
  // Alert window closed when popup close event called.
  $commands[] = ajax_command_alert('Window openned');
}

/*
 * @} End of "addtogroup hooks".
 */
