<?php

/**
 * @file
 * Views handlers for Node popup module.
 */

/**
 * A handler to provide a field that is completely custom by the administrator.
 *
 * @ingroup views_field_handlers
 */
class Npophandlerfieldnpop extends views_handler_field_node {

  /**
   * Public function optiondefinition.
   *
   * @return array
   *   Public function optiondefinition array.
   */
  public function optiondefinition() {
    $options = parent::optiondefinition();
    $options['node_to_npop'] = array('default' => isset($this->definition['node_to_npop default']) ? $this->definition['node_to_npop default'] : FALSE, 'bool' => FALSE);
    return $options;
  }

  /**
   * Provide node in colorbox option.
   */
  public function optionsform(&$form, &$form_state) {
    parent::optionsform($form, $form_state);
    $form['link_to_node']['#weight'] = -90;
    $form['node_to_npop'] = array(
      '#type' => 'checkbox',
      '#title' => t('Display the content inside of a popup window (Node popup).'),
      '#description' => t("Enable if you want show node in popup window."),
      '#default_value' => !empty($this->options['node_to_npop']),
      '#dependency' => array(
        'edit-options-link-to-node' => array(1),
      ),
      '#weight' => -80,
    );

    $form['alter']['path']['#states']['disabled'] = array(
      ':input[name="options[node_to_npop]"]' => array('checked' => TRUE),
    );
  }

  /**
   * Change node link to npop link to the query params.
   */
  public function renderlink($data, $values) {
    parent::renderlink($data, $values);
    if (!empty($this->options['link_to_node']) && !empty($this->additional_fields['nid'])) {
      if (!empty($this->options['node_to_npop'])) {
        $nid = $this->get_value($values, 'nid');
        $this->options['alter']['path'] = 'ajax/npop/node/' . $nid . '/load/nojs';
        if (isset($this->options['alter']['link_class'])) {
          $link_class = $this->options['alter']['link_class'];
        }
        else {
          $link_class = 'use-ajax';
        }
        if (strpos($link_class, 'use-ajax') === FALSE) {
          $link_class .= ' use-ajax';
        }
        $this->options['alter']['link_class'] = $link_class;
      }
    }
    return $data;
  }

}
